use wasm_bindgen::{prelude::Closure, JsCast};

pub fn button(document:&web_sys::Document, text:&str, callback:fn(web_sys::Event)) -> Result<web_sys::Element,()>
{
    match document.create_element("button") {
        Ok(element) => {
            element.set_text_content(Some(text));

            let cl = Closure::wrap(Box::new(callback) as Box<dyn FnMut(_)>);
            element.add_event_listener_with_callback("click", cl.as_ref().unchecked_ref()).ok();
            cl.forget();
            Ok(element)
        }
        Err(_) => Err(())
    }
}
