#![allow(dead_code)]

use std::cell::RefCell;

use wasm_bindgen::prelude::*;

mod ext;
mod prelude;
mod app; use app::*;

static mut APP :RefCell<Option<App>> = RefCell::new(None);

#[wasm_bindgen(start)]
fn main() -> Result<(),JsValue>
{
    match App::init() {
        Ok(app) => {
            unsafe {
                APP = RefCell::new(Some(app));

                let mut app = APP.borrow_mut();
                match &mut *app {
                    Some(app) => {
                        app.load::<scene::SceneListOnline>();
                    } None => { }
                }
            }
        }
        Err(_) => { }
    }
    Ok(())
}
