pub mod user; use user::User;
pub mod session; use session::Session;
pub mod contest; use contest::Contest;
pub mod context;

pub struct App {
    users:Pool<User>,
    salts:Vec<[u8; 16]>,
    sessions:Pool<Session>,
    contests:Pool<Contest>,
}
impl App {
    pub fn new() -> Self
    {
        Self {
            users:Pool::new(),
            salts:Vec::new(),
            sessions:Pool::new(),
            contests:Pool::new(),
        }
    }

    pub fn init(&mut self) -> Result<(),std::io::Error>
    { use std::{path::Path, fs};
        
        let path_data = Path::new("data");
        if !path_data.exists() {
            fs::create_dir(path_data)?;
            fs::create_dir(path_data.join("session"))?;
            fs::create_dir(path_data.join("user"))?;

            fs::write(path_data.join("user/index"), pack_u32(0));
        }

        Ok(())
    }
}
