use std::net::SocketAddr;

use bus::Bus;

mod util;
mod app;
mod system;
mod protocol;

use app::App;
use net::Server;
use protocol::QRPacket;

struct ServiceArgs {
    bus:Bus<protocol::QRPacket>,
}

async fn thread_datasystem(mut _app:App, bus:Bus<protocol::QRPacket>)
{
    use protocol::QRPacket;
    use game::protocol::packet::*;

    while match bus.receive_wait() {
        Some(packet) => {
            match packet.data {
                QRPacket::QAuthenticate(request) => {
                    let mut response = PacketAuthResponse::new();

                    // get user id from handle

                    // get user salt

                    // hash request secret

                    // compare hash to user secret
                    
                    // return response
                    bus.send(packet.from, QRPacket::RAuth(response)).is_ok()
                }
                _ => { true }
            }
        }
        None => false,
    } { }
}

fn handle_tcp(stream:net::tls::TlsStream, addr:SocketAddr, args:SericeArgs)
{
    use game::util::unpack_u32;

    let length = vec![0u8; 4];
    match stream.recv(&mut length) {
        Ok(4) => {
            let buffer = Vec::<u8>::with_capacity(unpack_u32(&length, &mut 0) as usize);
            match stream.recv(&mut buffer) {

            }
        }

        Ok(_) => {
            
        }

        Err(_) => { }
    }
}

#[tokio::main]
async fn main()
{
    use system::net::{
        tls::*,
        certstore::CertStore,
    };

    // Initialize application data.
    let mut app = App::new();
    if app.init().is_err() {
        println!("fatal: failed to initialize server.");
        return;
    }


    // Initialize service data.
    //let cs = CertStore::new();
    //cs.add("omen.kirisame.com", "cert/fullchain.pem", "cert/privkey.pem").ok();
    //let cs = cs.to_share();


    // Initialize central bus and data serivce.
    let bus = Bus::<protocol::QRPacket>::new_as(bus::Mode::Transmitter);
    match bus.connect() {
        Ok(bus) => {
            tokio::spawn(move || { thread_datasystem(app, bus); });
        }
        Err(_) => {
            println!("fatal: failed to initialize bus.");
            return;
        }
    }


    // Initialize HTTPS service.
    match bus.connect() {
        Ok(bus) => {
            // bind 38611
        }
        Err(_) => {
            println!("error: failed to initialize HTTPS service.");
        }
    }

    // Initialize TLS service.
    match bus.connect() {
        Ok(bus) => {
            // bind 38612
        }
        Err(_) => {
            println!("error: failed to initialize TLS service.");
        }
    }

    std::thread::park();
}
